#include "RecursiveDepthFirstSearcher.h"

/**
 * DepthFirstSearcher.cc - a simple recursive implementation of
 * depth-first search.
 *
 * @author Todd Neller
 * @version 1.0
 *

Copyright (C) 2003 Todd Neller

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

Information about the GNU General Public License is available online at:
  http://www.gnu.org/licenses/
To receive a copy of the GNU General Public License, write to the Free
Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
02111-1307, USA.

 */

/**
 * <code>search</code> - given an initial node, perform
 * depth-first search (DFS).  This particular implementation of
 * DFS is recursive.
 *
 * @param rootNode a <code>SearchNode *</code> value - the initial node
 * @return a <code>bool</code> value - whether or not goal node
 * was found */
bool RecursiveDepthFirstSearcher::search(SearchNode *rootNode) {

  // implement search initialization and first recursive call
  return false;
}


/**
 * <code>searchRecursive</code> - auxiliary recursive depth-first
 * search function.
 *
 * @param node a <code>SearchNode *</code> value - the current search node
 * @return a <code>bool</code> value - whether or not goal node
 * was found */
bool RecursiveDepthFirstSearcher::searchRecursive(SearchNode *node) {

  // implement

  // increment node count
	
  // If the search node is a goal node, store it and return
  // with success (true).
	    
  // Otherwise, recursively search each child until a goal node
  // is found or all children are searched.

	// Goal found through child - terminate with success

  // No goal found through any children, terminate with failure

  return false;
}


